<%@ Page	trace="true"
			language="c#" 
			AutoEventWireup="false" 
			Inherits="System.Web.UI.Page" 
			ContentType="text/xml" 
%>

<%@ Import Namespace="System.Web"  %>
<%@ Import Namespace="System.Collections"  %>
<%@ Import Namespace="System.Xml"  %>
<%@ Import Namespace="System.Diagnostics"  %>

<script runat=server >		
		private string LogName = "Application";	//by default

		override protected void OnInit(EventArgs e)
		{
			
			base.OnInit(e);
			WriteResponse();
		}

		private void WriteResponse()
		{
			Response.Buffer = true;
			Response.Clear();
			Response.Cache.SetCacheability(HttpCacheability.NoCache);
			Response.ContentType = "text/xml";
			Response.AddHeader("Content-Disposition","inline;filename=crm_log.xml");

			WriteRss();

			Response.End();
		}
		
		private const string dcNamespace = "http://purl.org/dc/elements/1.1/";

        private string getCurrentFullURL = null;
        public string GetCurrentFullURL
        {
            get
            {
                if (getCurrentFullURL == null)
                {
                    System.Web.HttpRequest Request = System.Web.HttpContext.Current.Request;
                    string CurrentURL = Request.Url.GetLeftPart(System.UriPartial.Authority) + (Request.ApplicationPath.Length == 1 ? String.Empty : Request.ApplicationPath);
                    getCurrentFullURL = CurrentURL;
                }
                return getCurrentFullURL;
            }
        }


		private void WriteRss()
		{
			XmlTextWriter wr = new XmlTextWriter(Response.OutputStream, System.Text.Encoding.UTF8);
			wr.Namespaces = true;
			wr.WriteProcessingInstruction("xml", "version='1.0' encoding='UTF-8'");
			wr.WriteProcessingInstruction("xml-stylesheet", "type='text/xsl' href='rssToTable.xsl' version='1.0'");
			wr.WriteStartElement("rss");
			wr.WriteAttributeString("version", "2.0");
			
			wr.WriteAttributeString("xmlns", "dc", null, dcNamespace);

			wr.WriteStartElement("channel");

			wr.WriteElementString("title", "Activities from Sprinx CRM on " + Environment.MachineName);
			wr.WriteElementString("description", "Activities logged in Sprinx CRM on " + Environment.MachineName);
			wr.WriteElementString("copyright", "This RSS feed is copyright (c) 2004-2007 by Sprinx. Resyndication and republication is expressly forbidden.");
			wr.WriteElementString("publisher", dcNamespace, "Sprinx Systems, a.s.");
            wr.WriteElementString("author", dcNamespace, "Sprinx Systems, a.s. (obchod@sprinx.cz)");
			wr.WriteElementString("language", dcNamespace, "en-US");

			WriteItems(wr);


			wr.WriteEndElement();//channel

			wr.WriteEndElement();
			wr.Flush();
			
		}

		private void WriteItems(XmlTextWriter wr)
		{
            using (System.Data.SqlClient.SqlConnection cnn = new System.Data.SqlClient.SqlConnection(System.Configuration.ConfigurationSettings.AppSettings["ConnectionString"]))
		    {
			    cnn.Open();

                string sql = @"select 
top 25

--*, 
Text as ActivityText,
ACT_ActivityType.Name as ActivityTypeName,
Users.Name as ActivityOwner,
view_CON_Contacts.Name as CustomerName,
ACT_BusinessOpportunity.Name as BusinessOpportunityName,
( ISNULL(ExpectedReceipts,0) - ISNULL(ExpectedCosts,0) ) as ExpectedRevenue ,
datediff( mi, StartDate, FinishDate ) as DurationInMinutes,
PublicNote,
StartDate,
FinishDate,
--TaskPercentCompleted,
--TaskCompletionDate,
OwnerName,
ManagerName,
FirmCategory,
Phone as ContactPhone,
WWW as ContactWWW,
City as ContactCity,
view_CON_Contacts.Email as ContactEmail,
SIGN( CHARINDEX('a', lower( FirmCategory ) ) ) as FirmCategoryIsA,
SIGN( CHARINDEX('b', lower( FirmCategory ) ) ) as FirmCategoryIsB,
SIGN( CHARINDEX('c', lower( FirmCategory ) ) ) as FirmCategoryIsC,
SIGN( CHARINDEX('w', lower( FirmCategory ) ) ) as FirmCategoryIsW,
ExpectedReceipts,
ExpectedCosts,
YEAR( StartDate ) as YearStartDate,
Month( StartDate ) as MonthStartDate,
Day( StartDate ) as DayStartDate,
YEAR( FinishDate ) as YearFinishDate,
Month( FinishDate ) as MonthFinishDate,
Day( FinishDate ) as DayFinishDate,
-----------------------------
id_Activity,
ACT_Activity.id_Customer,
ACT_Activity.id_BusinessOpportunity,
ACT_Activity.IsActive,
view_CON_Contacts.IsActive as ContactIsActive,
Users.IsActive as UserIsActive,
ACT_ActivityType.IsActive as ActivityTypeIsActive,
ACT_Activity.CreatedDate as ActivityCreatedDate,
ACT_Activity.IsPrivate as ActivityIsPrivate,
ACT_ActivityType.ActivityKind as ActivityTypeKind
from Users
left join ACT_Activity ON ACT_Activity.id_Owner = UserID
left join view_CON_Contacts ON id_Customer = id_Contact
left join ACT_BusinessOpportunity ON ACT_BusinessOpportunity.id_BusinessOpportunity = ACT_Activity.id_BusinessOpportunity
left join ACT_ActivityType on ACT_ActivityType.id_ActivityType = ACT_Activity.id_ActivityType

where users.isActive = 1 AND ISNULL(ACT_Activity.IsPrivate,0) = 0 AND ACT_Activity.IsActive = 1 AND ACT_ActivityType.IsActive = 1 order by id_Activity desc";
    			
			    using( System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand( sql, cnn ) ) {
			       System.Data.SqlClient.SqlDataAdapter adapter = new System.Data.SqlClient.SqlDataAdapter(cmd);
                   System.Data.DataTable dtAuthors = new System.Data.DataTable();

                   adapter.Fill(dtAuthors); 
                   foreach( System.Data.DataRow entry in dtAuthors.Rows ) 
                   {			    
				     WriteOneItem( wr, entry );
				   }
				    
			    }
		    }
		}

		private void WriteOneItem(XmlTextWriter wr, System.Data.DataRow entry)
		{
			wr.WriteStartElement("item");

            string boname = String.Empty + entry["BusinessOpportunityName"];
            string title = entry["ActivityText"] + ": " + entry["ActivityOwner"];
            if ( boname.Length > 0 ) {
              title += " (" + boname + ")";
            }
            //string dates = ((DateTime)entry["ActivityCreatedDate"]).ToUniversalTime().ToString("ddd, dd MMM yyyy  HH:mm:ss 'GMT'");
            string dates = ((DateTime)entry["ActivityCreatedDate"]).ToString();
            title += " " + dates;

			wr.WriteElementString("title", title );
            
            //wr.WriteElementString("pubDate", dates /*((DateTime)entry["ActivityCreatedDate"]).ToUniversalTime().ToString("ddd, dd MMM yyyy  HH:mm:ss 'GMT'")*/);
            System.Globalization.CultureInfo ci;
            ci = new System.Globalization.CultureInfo("en-US");
            wr.WriteElementString("pubDate", ((DateTime)entry["ActivityCreatedDate"]).ToUniversalTime().ToString("ddd, dd MMM yyyy  HH:mm:ss 'GMT'", ci));
            wr.WriteElementString("date", dates);
            
            wr.WriteStartElement("guid");
			wr.WriteAttributeString("isPermaLink", "false");
			wr.WriteString(GetEntryUniqueID(entry));
			wr.WriteEndElement();//guid
			wr.WriteElementString("description", GetItemText(entry));

			wr.WriteElementString("creator", dcNamespace, entry["ActivityOwner"].ToString());
			wr.WriteElementString("link", GetEntryUniqueID( entry ) );
			wr.WriteEndElement();//item
		}

		private string GetEntryUniqueID(System.Data.DataRow entry)
		{
            object kind = entry["ActivityTypeKind"];
            string skind = ( String.Empty + kind ).Trim();
            if (skind.Length > 0)
            {
                int ikind = Int32.Parse(skind);
                if (ikind == 1)
                {
                    return string.Format("{1}/DesktopModules/Activities/EditTask.aspx?IDTask={0}&mid=-1&tabid=5000&highlightTabId=5000&GoBackUrl=", entry["id_Activity"], GetCurrentFullURL);
                }
            }
            return string.Format("{1}/DesktopModules/Activities/EditEvent.aspx?IDEvent={0}&mid=-1&tabid=5000&highlightTabId=5000&GoBackUrl=&kind=" + kind, entry["id_Activity"], GetCurrentFullURL);				
		}

		private string GetBO(System.Data.DataRow entry)
		{
            return string.Format("{1}/DesktopModules/Activities/BusinessOpportunityDetail.aspx?Id={0}&tabid=&mid=-1&FirmBookmarkID=5&SelectedTab=0&GoBackUrl=", entry["id_BusinessOpportunity"], GetCurrentFullURL);				
		}

		private string GetCust(System.Data.DataRow entry)
		{
            return string.Format("{1}/DesktopModules/Contacts/ShowFirmDetail.aspx?tabid=&Id_Contact={0}&mid=-1&highlightTabId=&GoBackUrl=", entry["id_Customer"], GetCurrentFullURL);				
		}

		private string GetItemText(System.Data.DataRow entry)
		{
            const string itemFormat =
                    "<h4>{5}</h4>" +
                      "<b>Activity Owner:</b> {0} <br>" +
                      "<b>Customer Category:</b> {1} <br>" +
                      "<b>Customer Name:</b> <a href=\"{9}\">{2}</a> <br>" +
                      "<b>Business Opportunity Name:</b> <a href=\"{8}\">{3}</a> <br>" +
                      "<b>ActivityTypeName:</b> {4} <br>" +
                      "<pre>{6}</pre> <br>"; /*+
					  "<a href=\"{7}\">More...</a>";*/

			return string.Format(itemFormat, entry["ActivityOwner"], entry["FirmCategory"], 
				entry["CustomerName"], entry["BusinessOpportunityName"], entry["ActivityTypeName"], entry["ActivityText"], entry["PublicNote"], 
				GetEntryUniqueID( entry ),
				GetBO( entry ), GetCust( entry )
		    );
		}

</script>

